Developer Documentation

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Modules Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
ACG::DrawMeshBase Class Reference

`#include <ACG/GL/DrawMesh.hh>`

Inheritance diagram for ACG::DrawMeshBase:

## Public Member Functions
unsigned int | getNumTris () const
unsigned int | getNumVerts () const
MeshCompiler * | getMeshCompiler ()
| get mesh compiler used to create the draw mesh
unsigned int | getNumSubsets () const
GLenum | getIndexType () const
| get index type of index buffer
GLuint | pickVertexIBO_opt ()
| get an index buffer mapping from openmesh vertices to drawmesh vbo vertices More...

## Protected Member Functions
void | deleteIbo ()
void | bindVbo ()
void | bindIbo ()
void | bindLineIbo ()
void | bindPickVertexIbo ()
void | createIndexBuffer ()
void | fillLineBuffer (size_t n_edges, void *data)
void | fillVertexBuffer ()
void | fillInvVertexMap (size_t n_vertices, void *data)

## Protected Attributes
GLuint | vbo_
GLuint | ibo_
size_t | numTris_
size_t | numVerts_
MeshCompiler * | meshComp_
GLuint | lineIBO_
| index buffer used in Wireframe / Hiddenline mode
GLenum | indexType_
| support for 2 and 4 byte unsigned integers
std::vector< char > | vertices_
VertexDeclaration * | vertexDecl_
| vertex buffer layout declaration with per vertex colors
VertexDeclaration * | vertexDeclEdgeCol_
| vertex buffer layout declaration with per edge colors
VertexDeclaration * | vertexDeclHalfedgeCol_
| vertex buffer layout declaration with per halfedge colors
VertexDeclaration * | vertexDeclHalfedgePos_
| vertex buffer layout declaration with halfedge positions only
GLuint | pickVertexIBO_
| map from openmesh vertex to vbo vertex id

## Detailed Description

This class holds non-templated code and is intended to be inherited by the templated DrawMeshT class.

Definition at line 91 of file DrawMesh.hh.

## Member Function Documentation

GLuint ACG::DrawMeshBase::pickVertexIBO_opt | ( |  | ) |
| inline

get an index buffer mapping from openmesh vertices to drawmesh vbo vertices

Returns
  index buffer object (UNSIGNED_INT), might be 0 if the openmesh object is a point cloud

Definition at line 124 of file DrawMesh.hh.

## Member Data Documentation

std::vector<char> ACG::DrawMeshBase::vertices_
| protected

final vertex buffer used for rendering raw byte array, use write__() functions for access

Definition at line 142 of file DrawMesh.hh.

The documentation for this class was generated from the following files:

- ACG/GL/DrawMesh.hh
- ACG/GL/DrawMesh.cc